
"""
Trait definitions in the 'timeline' namespace.

Traits related to timelines.
"""

# WARNING: This file is auto-generated by openassetio-traitgen, do not edit.

from typing import Union

from openassetio import TraitBase


class ClipTrait(TraitBase):
    """
    This trait characterizes the use of some range of external media,
    commonly on a track or timeline. Frequently used in non-linear
    editing environments such as Video and Audio production tools.

    TODO(TC) Define any additional properties, and companion traits such
    as 'frameRange' and 'handles'.
    """
    kId = "openassetio-mediacreation:timeline.Clip"

    
    def setName(self, name: str):
        """
        Sets the name property.

        The name of the clip.
        """
        if not isinstance(name, str):
            raise TypeError("name must be a 'str'.")
        self._data.setTraitProperty(self.kId, "name", name)

    def getName(self, defaultValue: str=None) -> Union[str, None]:
        """
        Gets the value of the name property or the supplied default.

        The name of the clip.
        """
        value = self._data.getTraitProperty(self.kId, "name")
        if value is None:
            return defaultValue

        if not isinstance(value, str):
            if defaultValue is None:
                raise TypeError(f"Invalid stored value type: '{type(value).__name__}' should be 'str'.")
            return defaultValue
        return value
        
    


class TimelineTrait(TraitBase):
    """
    This trait characterizes a collection of tracks that evaluate
    concurrently to form layers of references to media. Frequently used
    in non-linear editing environments such as Video and Audio post
    production tools.
    """
    kId = "openassetio-mediacreation:timeline.Timeline"

    


class TrackTrait(TraitBase):
    """
    This trait characterizes a lane or collection of media, arranged
    temporally such that only a single item in the collection is active
    at any given time. Frequently used in non-linear editing
    environments such as Video and Audio post production tools.
    """
    kId = "openassetio-mediacreation:timeline.Track"

    

